/* This file was generated by SableCC (http://www.sablecc.org/). */

package minibasic.lexer;

import java.io.*;
import java.util.*;
import minibasic.node.*;

public class Lexer
{
    protected Token token;
    protected State state = State.INITIAL;

    private PushbackReader in;
    private int line;
    private int pos;
    private boolean cr;
    private boolean eof;
    private final StringBuffer text = new StringBuffer();

    protected void filter() throws LexerException, IOException
    {
    }

    public Lexer(PushbackReader in)
    {
        this.in = in;
    }
 
    public Token peek() throws LexerException, IOException
    {
        while(token == null)
        {
            token = getToken();
            filter();
        }

        return token;
    }

    public Token next() throws LexerException, IOException
    {
        while(token == null)
        {
            token = getToken();
            filter();
        }

        Token result = token;
        token = null;
        return result;
    }

    protected Token getToken() throws IOException, LexerException
    {
        int dfa_state = 0;

        int start_pos = pos;
        int start_line = line;

        int accept_state = -1;
        int accept_token = -1;
        int accept_length = -1;
        int accept_pos = -1;
        int accept_line = -1;

        int[][][] gotoTable = this.gotoTable[state.id()];
        int[] accept = this.accept[state.id()];
        text.setLength(0);

        while(true)
        {
            int c = getChar();

            if(c != -1)
            {
                switch(c)
                {
                case 10:
                    if(cr)
                    {
                        cr = false;
                    }
                    else
                    {
                        line++;
                        pos = 0;
                    }
                    break;
                case 13:
                    line++;
                    pos = 0;
                    cr = true;
                    break;
                default:
                    pos++;
                    cr = false;
                    break;
                };

                text.append((char) c);

                do
                {
                    int oldState = (dfa_state < -1) ? (-2 -dfa_state) : dfa_state;

                    dfa_state = -1;

                    int[][] tmp1 =  gotoTable[oldState];
                    int low = 0;
                    int high = tmp1.length - 1;

                    while(low <= high)
                    {
                        int middle = (low + high) / 2;
                        int[] tmp2 = tmp1[middle];

                        if(c < tmp2[0])
                        {
                            high = middle - 1;
                        }
                        else if(c > tmp2[1])
                        {
                            low = middle + 1;
                        }
                        else
                        {
                            dfa_state = tmp2[2];
                            break;
                        }
                    }
                }while(dfa_state < -1);
            }
            else
            {
                dfa_state = -1;
            }

            if(dfa_state >= 0)
            {
                if(accept[dfa_state] != -1)
                {
                    accept_state = dfa_state;
                    accept_token = accept[dfa_state];
                    accept_length = text.length();
                    accept_pos = pos;
                    accept_line = line;
                }
            }
            else
            {
                if(accept_state != -1)
                {
                    switch(accept_token)
                    {
                    case 0:
                        {
                            Token token = new0(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 1:
                        {
                            Token token = new1(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 2:
                        {
                            Token token = new2(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 3:
                        {
                            Token token = new3(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 4:
                        {
                            Token token = new4(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 5:
                        {
                            Token token = new5(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 6:
                        {
                            Token token = new6(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 7:
                        {
                            Token token = new7(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 8:
                        {
                            Token token = new8(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 9:
                        {
                            Token token = new9(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 10:
                        {
                            Token token = new10(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 11:
                        {
                            Token token = new11(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 12:
                        {
                            Token token = new12(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 13:
                        {
                            Token token = new13(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 14:
                        {
                            Token token = new14(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 15:
                        {
                            Token token = new15(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 16:
                        {
                            Token token = new16(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 17:
                        {
                            Token token = new17(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 18:
                        {
                            Token token = new18(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 19:
                        {
                            Token token = new19(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 20:
                        {
                            Token token = new20(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 21:
                        {
                            Token token = new21(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 22:
                        {
                            Token token = new22(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 23:
                        {
                            Token token = new23(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 24:
                        {
                            Token token = new24(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 25:
                        {
                            Token token = new25(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    }
                }
                else
                {
                    if(text.length() > 0)
                    {
                        throw new LexerException(
                            "[" + (start_line + 1) + "," + (start_pos + 1) + "]" +
                            " Unknown token: " + text);
                    }
                    else
                    {
                        EOF token = new EOF(
                            start_line + 1,
                            start_pos + 1);
                        return token;
                    }
                }
            }
        }
    }

    Token new0(int line, int pos) { return new TIf(line, pos); }
    Token new1(int line, int pos) { return new TThen(line, pos); }
    Token new2(int line, int pos) { return new TElse(line, pos); }
    Token new3(int line, int pos) { return new TEndif(line, pos); }
    Token new4(int line, int pos) { return new TFor(line, pos); }
    Token new5(int line, int pos) { return new TTo(line, pos); }
    Token new6(int line, int pos) { return new TNext(line, pos); }
    Token new7(int line, int pos) { return new TRead(line, pos); }
    Token new8(int line, int pos) { return new TPrint(line, pos); }
    Token new9(int line, int pos) { return new TPrintln(line, pos); }
    Token new10(int line, int pos) { return new TAssign(line, pos); }
    Token new11(int line, int pos) { return new TLessThan(line, pos); }
    Token new12(int line, int pos) { return new TGreaterThan(line, pos); }
    Token new13(int line, int pos) { return new TEqual(line, pos); }
    Token new14(int line, int pos) { return new TPlus(line, pos); }
    Token new15(int line, int pos) { return new TMinus(line, pos); }
    Token new16(int line, int pos) { return new TMult(line, pos); }
    Token new17(int line, int pos) { return new TDiv(line, pos); }
    Token new18(int line, int pos) { return new TMod(line, pos); }
    Token new19(int line, int pos) { return new TLPar(line, pos); }
    Token new20(int line, int pos) { return new TRPar(line, pos); }
    Token new21(String text, int line, int pos) { return new TIdentifier(text, line, pos); }
    Token new22(String text, int line, int pos) { return new TNumber(text, line, pos); }
    Token new23(String text, int line, int pos) { return new TString(text, line, pos); }
    Token new24(String text, int line, int pos) { return new TNewLine(text, line, pos); }
    Token new25(String text, int line, int pos) { return new TBlank(text, line, pos); }

    private int getChar() throws IOException
    {
        if(eof)
        {
            return -1;
        }

        int result = in.read();

        if(result == -1)
        {
            eof = true;
        }

        return result;
    }

    private void pushBack(int acceptLength) throws IOException
    {
        int length = text.length();
        for(int i = length - 1; i >= acceptLength; i--)
        {
            eof = false;

            in.unread(text.charAt(i));
        }
    }

    protected void unread(Token token) throws IOException
    {
        String text = token.getText();
        int length = text.length();

        for(int i = length - 1; i >= 0; i--)
        {
            eof = false;

            in.unread(text.charAt(i));
        }

        pos = token.getPos() - 1;
        line = token.getLine() - 1;
    }

    private String getText(int acceptLength)
    {
        StringBuffer s = new StringBuffer(acceptLength);
        for(int i = 0; i < acceptLength; i++)
        {
            s.append(text.charAt(i));
        }

        return s.toString();
    }

    private static int[][][][] gotoTable;
/*  {
        { // INITIAL
            {{10, 10, 1}, {13, 13, 2}, {32, 32, 3}, {34, 34, 4}, {37, 37, 5}, {40, 40, 6}, {41, 41, 7}, {42, 42, 8}, {43, 43, 9}, {45, 45, 10}, {47, 47, 11}, {48, 57, 12}, {58, 58, 13}, {60, 60, 14}, {61, 61, 15}, {62, 62, 16}, {65, 68, 17}, {69, 69, 18}, {70, 70, 19}, {71, 72, 17}, {73, 73, 20}, {74, 77, 17}, {78, 78, 21}, {79, 79, 17}, {80, 80, 22}, {81, 81, 17}, {82, 82, 23}, {83, 83, 17}, {84, 84, 24}, {85, 90, 17}, },
            {},
            {{10, 10, 25}, },
            {{32, 32, 3}, },
            {{32, 33, 26}, {34, 34, 27}, {35, 127, 26}, },
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {{48, 57, 12}, },
            {{61, 61, 28}, },
            {},
            {},
            {},
            {{48, 57, 29}, {65, 90, 30}, },
            {{48, 57, 29}, {65, 75, 30}, {76, 76, 31}, {77, 77, 30}, {78, 78, 32}, {79, 90, 30}, },
            {{48, 57, 29}, {65, 78, 30}, {79, 79, 33}, {80, 90, 30}, },
            {{48, 57, 29}, {65, 69, 30}, {70, 70, 34}, {71, 90, 30}, },
            {{48, 57, 29}, {65, 68, 30}, {69, 69, 35}, {70, 90, 30}, },
            {{48, 57, 29}, {65, 81, 30}, {82, 82, 36}, {83, 90, 30}, },
            {{48, 68, -23}, {69, 69, 37}, {70, 90, 30}, },
            {{48, 57, 29}, {65, 71, 30}, {72, 72, 38}, {73, 78, 30}, {79, 79, 39}, {80, 90, 30}, },
            {},
            {{32, 127, -6}, },
            {},
            {},
            {{48, 90, -19}, },
            {{48, 90, -19}, },
            {{48, 57, 29}, {65, 82, 30}, {83, 83, 40}, {84, 90, 30}, },
            {{48, 57, 29}, {65, 67, 30}, {68, 68, 41}, {69, 90, 30}, },
            {{48, 81, -24}, {82, 82, 42}, {83, 90, 30}, },
            {{48, 90, -19}, },
            {{48, 57, 29}, {65, 87, 30}, {88, 88, 43}, {89, 90, 30}, },
            {{48, 57, 29}, {65, 72, 30}, {73, 73, 44}, {74, 90, 30}, },
            {{48, 57, 29}, {65, 65, 45}, {66, 90, 30}, },
            {{48, 68, -23}, {69, 69, 46}, {70, 90, 30}, },
            {{48, 90, -19}, },
            {{48, 68, -23}, {69, 69, 47}, {70, 90, 30}, },
            {{48, 72, -38}, {73, 73, 48}, {74, 90, 30}, },
            {{48, 90, -19}, },
            {{48, 57, 29}, {65, 83, 30}, {84, 84, 49}, {85, 90, 30}, },
            {{48, 57, 29}, {65, 77, 30}, {78, 78, 50}, {79, 90, 30}, },
            {{48, 67, -34}, {68, 68, 51}, {69, 90, 30}, },
            {{48, 77, -46}, {78, 78, 52}, {79, 90, 30}, },
            {{48, 90, -19}, },
            {{48, 69, -22}, {70, 70, 53}, {71, 90, 30}, },
            {{48, 90, -19}, },
            {{48, 83, -45}, {84, 84, 54}, {85, 90, 30}, },
            {{48, 90, -19}, },
            {{48, 90, -19}, },
            {{48, 90, -19}, },
            {{48, 75, -20}, {76, 76, 55}, {77, 90, 30}, },
            {{48, 77, -46}, {78, 78, 56}, {79, 90, 30}, },
            {{48, 90, -19}, },
        }
    };*/

    private static int[][] accept;
/*  {
        // INITIAL
        {25, 24, 24, 25, -1, 18, 19, 20, 16, 14, 15, 17, 22, -1, 11, 13, 12, 21, 21, 21, 21, 21, 21, 21, 21, 24, -1, 23, 10, 21, 21, 21, 21, 21, 0, 21, 21, 21, 21, 5, 21, 21, 4, 21, 21, 21, 21, 2, 21, 6, 21, 7, 1, 3, 8, 21, 9, },

    };*/

    public static class State
    {
        public final static State INITIAL = new State(0);

        private int id;

        private State(int id)
        {
            this.id = id;
        }

        public int id()
        {
            return id;
        }
    }

    static 
    {
        try
        {
            DataInputStream s = new DataInputStream(
                new BufferedInputStream(
                Lexer.class.getResourceAsStream("lexer.dat")));

            // read gotoTable
            int length = s.readInt();
            gotoTable = new int[length][][][];
            for(int i = 0; i < gotoTable.length; i++)
            {
                length = s.readInt();
                gotoTable[i] = new int[length][][];
                for(int j = 0; j < gotoTable[i].length; j++)
                {
                    length = s.readInt();
                    gotoTable[i][j] = new int[length][3];
                    for(int k = 0; k < gotoTable[i][j].length; k++)
                    {
                        for(int l = 0; l < 3; l++)
                        {
                            gotoTable[i][j][k][l] = s.readInt();
                        }
                    }
                }
            }

            // read accept
            length = s.readInt();
            accept = new int[length][];
            for(int i = 0; i < accept.length; i++)
            {
                length = s.readInt();
                accept[i] = new int[length];
                for(int j = 0; j < accept[i].length; j++)
                {
                    accept[i][j] = s.readInt();
                }
            }

            s.close();
        }
        catch(Exception e)
        {
            throw new RuntimeException("The file \"lexer.dat\" is either missing or corrupted.");
        }
    }
}
