/* This file was generated by SableCC (http://www.sablecc.org/). */

package minibasic.parser;

import minibasic.lexer.*;
import minibasic.node.*;
import minibasic.analysis.*;
import java.util.*;

import java.io.DataInputStream;
import java.io.BufferedInputStream;
import java.io.IOException;

public class Parser
{
    public final Analysis ignoredTokens = new AnalysisAdapter();

    protected ArrayList nodeList;

    private final Lexer lexer;
    private final ListIterator stack = new LinkedList().listIterator();
    private int last_shift;
    private int last_pos;
    private int last_line;
    private Token last_token;
    private final TokenIndex converter = new TokenIndex();
    private final int[] action = new int[2];

    private final static int SHIFT = 0;
    private final static int REDUCE = 1;
    private final static int ACCEPT = 2;
    private final static int ERROR = 3;

    public Parser(Lexer lexer)
    {
        this.lexer = lexer;
    }

    protected void filter() throws ParserException, LexerException, IOException
    {
    }

    private void push(int numstate, ArrayList listNode, boolean hidden) throws ParserException, LexerException, IOException
    {
	this.nodeList = listNode;

        if(!hidden)
        {
            filter();
        }

        if(!stack.hasNext())
        {
            stack.add(new State(numstate, this.nodeList));
            return;
        }

        State s = (State) stack.next();
        s.state = numstate;
        s.nodes = this.nodeList;
    }

    private int goTo(int index)
    {
        int state = state();
        int low = 1;
        int high = gotoTable[index].length - 1;
        int value = gotoTable[index][0][1];

        while(low <= high)
        {
            int middle = (low + high) / 2;

            if(state < gotoTable[index][middle][0])
            {
                high = middle - 1;
            }
            else if(state > gotoTable[index][middle][0])
            {
                low = middle + 1;
            }
            else
            {
                value = gotoTable[index][middle][1];
                break;
            }
        }

        return value;
    }

    private int state()
    {
        State s = (State) stack.previous();
        stack.next();
        return s.state;
    }

    private ArrayList pop()
    {
        return (ArrayList) ((State) stack.previous()).nodes;
    }

    private int index(Switchable token)
    {
        converter.index = -1;
        token.apply(converter);
        return converter.index;
    }

    public Start parse() throws ParserException, LexerException, IOException
    {
        push(0, null, true);
        List ign = null;
        while(true)
        {
            while(index(lexer.peek()) == -1)
            {
                if(ign == null)
                {
                    ign = new TypedLinkedList(NodeCast.instance);
                }

                ign.add(lexer.next());
            }

            if(ign != null)
            {
                ignoredTokens.setIn(lexer.peek(), ign);
                ign = null;
            }

            last_pos = lexer.peek().getPos();
            last_line = lexer.peek().getLine();
            last_token = lexer.peek();

            int index = index(lexer.peek());
            action[0] = actionTable[state()][0][1];
            action[1] = actionTable[state()][0][2];

            int low = 1;
            int high = actionTable[state()].length - 1;

            while(low <= high)
            {
                int middle = (low + high) / 2;

                if(index < actionTable[state()][middle][0])
                {
                    high = middle - 1;
                }
                else if(index > actionTable[state()][middle][0])
                {
                    low = middle + 1;
                }
                else
                {
                    action[0] = actionTable[state()][middle][1];
                    action[1] = actionTable[state()][middle][2];
                    break;
                }
            }

            switch(action[0])
            {
                case SHIFT:
		    {
		        ArrayList list = new ArrayList();
		        list.add(lexer.next());
                        push(action[1], list, false);
                        last_shift = action[1];
                    }
		    break;
                case REDUCE:
                    switch(action[1])
                    {
                    case 0: /* reduce AListStatements */
		    {
			ArrayList list = new0();
			push(goTo(0), list, false);
		    }
		    break;
                    case 1: /* reduce AEmptyStatements */
		    {
			ArrayList list = new1();
			push(goTo(0), list, false);
		    }
		    break;
                    case 2: /* reduce AIfStatement */
		    {
			ArrayList list = new2();
			push(goTo(1), list, false);
		    }
		    break;
                    case 3: /* reduce AForStatement */
		    {
			ArrayList list = new3();
			push(goTo(1), list, false);
		    }
		    break;
                    case 4: /* reduce AReadStatement */
		    {
			ArrayList list = new4();
			push(goTo(1), list, false);
		    }
		    break;
                    case 5: /* reduce APrintExpStatement */
		    {
			ArrayList list = new5();
			push(goTo(1), list, false);
		    }
		    break;
                    case 6: /* reduce APrintStrStatement */
		    {
			ArrayList list = new6();
			push(goTo(1), list, false);
		    }
		    break;
                    case 7: /* reduce APrintlnStatement */
		    {
			ArrayList list = new7();
			push(goTo(1), list, false);
		    }
		    break;
                    case 8: /* reduce AAssignmentStatement */
		    {
			ArrayList list = new8();
			push(goTo(1), list, false);
		    }
		    break;
                    case 9: /* reduce AElseOptionalElse */
		    {
			ArrayList list = new9();
			push(goTo(2), list, false);
		    }
		    break;
                    case 10: /* reduce AEmptyOptionalElse */
		    {
			ArrayList list = new10();
			push(goTo(2), list, false);
		    }
		    break;
                    case 11: /* reduce ALessThanCondition */
		    {
			ArrayList list = new11();
			push(goTo(3), list, false);
		    }
		    break;
                    case 12: /* reduce AGreaterThanCondition */
		    {
			ArrayList list = new12();
			push(goTo(3), list, false);
		    }
		    break;
                    case 13: /* reduce AEqualCondition */
		    {
			ArrayList list = new13();
			push(goTo(3), list, false);
		    }
		    break;
                    case 14: /* reduce AValueExpression */
		    {
			ArrayList list = new14();
			push(goTo(4), list, false);
		    }
		    break;
                    case 15: /* reduce APlusExpression */
		    {
			ArrayList list = new15();
			push(goTo(4), list, false);
		    }
		    break;
                    case 16: /* reduce AMinusExpression */
		    {
			ArrayList list = new16();
			push(goTo(4), list, false);
		    }
		    break;
                    case 17: /* reduce AMultExpression */
		    {
			ArrayList list = new17();
			push(goTo(4), list, false);
		    }
		    break;
                    case 18: /* reduce ADivExpression */
		    {
			ArrayList list = new18();
			push(goTo(4), list, false);
		    }
		    break;
                    case 19: /* reduce AModExpression */
		    {
			ArrayList list = new19();
			push(goTo(4), list, false);
		    }
		    break;
                    case 20: /* reduce AConstantValue */
		    {
			ArrayList list = new20();
			push(goTo(5), list, false);
		    }
		    break;
                    case 21: /* reduce AIdentifierValue */
		    {
			ArrayList list = new21();
			push(goTo(5), list, false);
		    }
		    break;
                    case 22: /* reduce AExpressionValue */
		    {
			ArrayList list = new22();
			push(goTo(5), list, false);
		    }
		    break;
                    }
                    break;
                case ACCEPT:
                    {
                        EOF node2 = (EOF) lexer.next();
                        PStatements node1 = (PStatements) ((ArrayList)pop()).get(0);
                        Start node = new Start(node1, node2);
                        return node;
                    }
                case ERROR:
                    throw new ParserException(last_token,
                        "[" + last_line + "," + last_pos + "] " +
                        errorMessages[errors[action[1]]]);
            }
        }
    }



    ArrayList new0() /* reduce AListStatements */
    {
        ArrayList nodeList = new ArrayList();

        ArrayList nodeArrayList2 = (ArrayList) pop();
        ArrayList nodeArrayList1 = (ArrayList) pop();
        PStatements pstatementsNode1;
        {
        PStatement pstatementNode2;
        PStatements pstatementsNode3;
        pstatementNode2 = (PStatement)nodeArrayList1.get(0);
        pstatementsNode3 = (PStatements)nodeArrayList2.get(0);

        pstatementsNode1 = new AListStatements(pstatementNode2, pstatementsNode3);
        }
	nodeList.add(pstatementsNode1);
        return nodeList;
    }



    ArrayList new1() /* reduce AEmptyStatements */
    {
        ArrayList nodeList = new ArrayList();

        PStatements pstatementsNode1;
        {

        pstatementsNode1 = new AEmptyStatements();
        }
	nodeList.add(pstatementsNode1);
        return nodeList;
    }



    ArrayList new2() /* reduce AIfStatement */
    {
        ArrayList nodeList = new ArrayList();

        ArrayList nodeArrayList8 = (ArrayList) pop();
        ArrayList nodeArrayList7 = (ArrayList) pop();
        ArrayList nodeArrayList6 = (ArrayList) pop();
        ArrayList nodeArrayList5 = (ArrayList) pop();
        ArrayList nodeArrayList4 = (ArrayList) pop();
        ArrayList nodeArrayList3 = (ArrayList) pop();
        ArrayList nodeArrayList2 = (ArrayList) pop();
        ArrayList nodeArrayList1 = (ArrayList) pop();
        PStatement pstatementNode1;
        {
        TIf tifNode2;
        PCondition pconditionNode3;
        TThen tthenNode4;
        TNewLine tnewlineNode5;
        PStatements pstatementsNode6;
        POptionalElse poptionalelseNode7;
        TEndif tendifNode8;
        TNewLine tnewlineNode9;
        tifNode2 = (TIf)nodeArrayList1.get(0);
        pconditionNode3 = (PCondition)nodeArrayList2.get(0);
        tthenNode4 = (TThen)nodeArrayList3.get(0);
        tnewlineNode5 = (TNewLine)nodeArrayList4.get(0);
        pstatementsNode6 = (PStatements)nodeArrayList5.get(0);
        poptionalelseNode7 = (POptionalElse)nodeArrayList6.get(0);
        tendifNode8 = (TEndif)nodeArrayList7.get(0);
        tnewlineNode9 = (TNewLine)nodeArrayList8.get(0);

        pstatementNode1 = new AIfStatement(tifNode2, pconditionNode3, tthenNode4, tnewlineNode5, pstatementsNode6, poptionalelseNode7, tendifNode8, tnewlineNode9);
        }
	nodeList.add(pstatementNode1);
        return nodeList;
    }



    ArrayList new3() /* reduce AForStatement */
    {
        ArrayList nodeList = new ArrayList();

        ArrayList nodeArrayList10 = (ArrayList) pop();
        ArrayList nodeArrayList9 = (ArrayList) pop();
        ArrayList nodeArrayList8 = (ArrayList) pop();
        ArrayList nodeArrayList7 = (ArrayList) pop();
        ArrayList nodeArrayList6 = (ArrayList) pop();
        ArrayList nodeArrayList5 = (ArrayList) pop();
        ArrayList nodeArrayList4 = (ArrayList) pop();
        ArrayList nodeArrayList3 = (ArrayList) pop();
        ArrayList nodeArrayList2 = (ArrayList) pop();
        ArrayList nodeArrayList1 = (ArrayList) pop();
        PStatement pstatementNode1;
        {
        TFor tforNode2;
        TIdentifier tidentifierNode3;
        TAssign tassignNode4;
        PExpression pexpressionNode5;
        TTo ttoNode6;
        PExpression pexpressionNode7;
        TNewLine tnewlineNode8;
        PStatements pstatementsNode9;
        TNext tnextNode10;
        TNewLine tnewlineNode11;
        tforNode2 = (TFor)nodeArrayList1.get(0);
        tidentifierNode3 = (TIdentifier)nodeArrayList2.get(0);
        tassignNode4 = (TAssign)nodeArrayList3.get(0);
        pexpressionNode5 = (PExpression)nodeArrayList4.get(0);
        ttoNode6 = (TTo)nodeArrayList5.get(0);
        pexpressionNode7 = (PExpression)nodeArrayList6.get(0);
        tnewlineNode8 = (TNewLine)nodeArrayList7.get(0);
        pstatementsNode9 = (PStatements)nodeArrayList8.get(0);
        tnextNode10 = (TNext)nodeArrayList9.get(0);
        tnewlineNode11 = (TNewLine)nodeArrayList10.get(0);

        pstatementNode1 = new AForStatement(tforNode2, tidentifierNode3, tassignNode4, pexpressionNode5, ttoNode6, pexpressionNode7, tnewlineNode8, pstatementsNode9, tnextNode10, tnewlineNode11);
        }
	nodeList.add(pstatementNode1);
        return nodeList;
    }



    ArrayList new4() /* reduce AReadStatement */
    {
        ArrayList nodeList = new ArrayList();

        ArrayList nodeArrayList3 = (ArrayList) pop();
        ArrayList nodeArrayList2 = (ArrayList) pop();
        ArrayList nodeArrayList1 = (ArrayList) pop();
        PStatement pstatementNode1;
        {
        TRead treadNode2;
        TIdentifier tidentifierNode3;
        TNewLine tnewlineNode4;
        treadNode2 = (TRead)nodeArrayList1.get(0);
        tidentifierNode3 = (TIdentifier)nodeArrayList2.get(0);
        tnewlineNode4 = (TNewLine)nodeArrayList3.get(0);

        pstatementNode1 = new AReadStatement(treadNode2, tidentifierNode3, tnewlineNode4);
        }
	nodeList.add(pstatementNode1);
        return nodeList;
    }



    ArrayList new5() /* reduce APrintExpStatement */
    {
        ArrayList nodeList = new ArrayList();

        ArrayList nodeArrayList3 = (ArrayList) pop();
        ArrayList nodeArrayList2 = (ArrayList) pop();
        ArrayList nodeArrayList1 = (ArrayList) pop();
        PStatement pstatementNode1;
        {
        TPrint tprintNode2;
        PExpression pexpressionNode3;
        TNewLine tnewlineNode4;
        tprintNode2 = (TPrint)nodeArrayList1.get(0);
        pexpressionNode3 = (PExpression)nodeArrayList2.get(0);
        tnewlineNode4 = (TNewLine)nodeArrayList3.get(0);

        pstatementNode1 = new APrintExpStatement(tprintNode2, pexpressionNode3, tnewlineNode4);
        }
	nodeList.add(pstatementNode1);
        return nodeList;
    }



    ArrayList new6() /* reduce APrintStrStatement */
    {
        ArrayList nodeList = new ArrayList();

        ArrayList nodeArrayList3 = (ArrayList) pop();
        ArrayList nodeArrayList2 = (ArrayList) pop();
        ArrayList nodeArrayList1 = (ArrayList) pop();
        PStatement pstatementNode1;
        {
        TPrint tprintNode2;
        TString tstringNode3;
        TNewLine tnewlineNode4;
        tprintNode2 = (TPrint)nodeArrayList1.get(0);
        tstringNode3 = (TString)nodeArrayList2.get(0);
        tnewlineNode4 = (TNewLine)nodeArrayList3.get(0);

        pstatementNode1 = new APrintStrStatement(tprintNode2, tstringNode3, tnewlineNode4);
        }
	nodeList.add(pstatementNode1);
        return nodeList;
    }



    ArrayList new7() /* reduce APrintlnStatement */
    {
        ArrayList nodeList = new ArrayList();

        ArrayList nodeArrayList2 = (ArrayList) pop();
        ArrayList nodeArrayList1 = (ArrayList) pop();
        PStatement pstatementNode1;
        {
        TPrintln tprintlnNode2;
        TNewLine tnewlineNode3;
        tprintlnNode2 = (TPrintln)nodeArrayList1.get(0);
        tnewlineNode3 = (TNewLine)nodeArrayList2.get(0);

        pstatementNode1 = new APrintlnStatement(tprintlnNode2, tnewlineNode3);
        }
	nodeList.add(pstatementNode1);
        return nodeList;
    }



    ArrayList new8() /* reduce AAssignmentStatement */
    {
        ArrayList nodeList = new ArrayList();

        ArrayList nodeArrayList4 = (ArrayList) pop();
        ArrayList nodeArrayList3 = (ArrayList) pop();
        ArrayList nodeArrayList2 = (ArrayList) pop();
        ArrayList nodeArrayList1 = (ArrayList) pop();
        PStatement pstatementNode1;
        {
        TIdentifier tidentifierNode2;
        TAssign tassignNode3;
        PExpression pexpressionNode4;
        TNewLine tnewlineNode5;
        tidentifierNode2 = (TIdentifier)nodeArrayList1.get(0);
        tassignNode3 = (TAssign)nodeArrayList2.get(0);
        pexpressionNode4 = (PExpression)nodeArrayList3.get(0);
        tnewlineNode5 = (TNewLine)nodeArrayList4.get(0);

        pstatementNode1 = new AAssignmentStatement(tidentifierNode2, tassignNode3, pexpressionNode4, tnewlineNode5);
        }
	nodeList.add(pstatementNode1);
        return nodeList;
    }



    ArrayList new9() /* reduce AElseOptionalElse */
    {
        ArrayList nodeList = new ArrayList();

        ArrayList nodeArrayList3 = (ArrayList) pop();
        ArrayList nodeArrayList2 = (ArrayList) pop();
        ArrayList nodeArrayList1 = (ArrayList) pop();
        POptionalElse poptionalelseNode1;
        {
        TElse telseNode2;
        TNewLine tnewlineNode3;
        PStatements pstatementsNode4;
        telseNode2 = (TElse)nodeArrayList1.get(0);
        tnewlineNode3 = (TNewLine)nodeArrayList2.get(0);
        pstatementsNode4 = (PStatements)nodeArrayList3.get(0);

        poptionalelseNode1 = new AElseOptionalElse(telseNode2, tnewlineNode3, pstatementsNode4);
        }
	nodeList.add(poptionalelseNode1);
        return nodeList;
    }



    ArrayList new10() /* reduce AEmptyOptionalElse */
    {
        ArrayList nodeList = new ArrayList();

        POptionalElse poptionalelseNode1;
        {

        poptionalelseNode1 = new AEmptyOptionalElse();
        }
	nodeList.add(poptionalelseNode1);
        return nodeList;
    }



    ArrayList new11() /* reduce ALessThanCondition */
    {
        ArrayList nodeList = new ArrayList();

        ArrayList nodeArrayList3 = (ArrayList) pop();
        ArrayList nodeArrayList2 = (ArrayList) pop();
        ArrayList nodeArrayList1 = (ArrayList) pop();
        PCondition pconditionNode1;
        {
        PExpression pexpressionNode2;
        TLessThan tlessthanNode3;
        PExpression pexpressionNode4;
        pexpressionNode2 = (PExpression)nodeArrayList1.get(0);
        tlessthanNode3 = (TLessThan)nodeArrayList2.get(0);
        pexpressionNode4 = (PExpression)nodeArrayList3.get(0);

        pconditionNode1 = new ALessThanCondition(pexpressionNode2, tlessthanNode3, pexpressionNode4);
        }
	nodeList.add(pconditionNode1);
        return nodeList;
    }



    ArrayList new12() /* reduce AGreaterThanCondition */
    {
        ArrayList nodeList = new ArrayList();

        ArrayList nodeArrayList3 = (ArrayList) pop();
        ArrayList nodeArrayList2 = (ArrayList) pop();
        ArrayList nodeArrayList1 = (ArrayList) pop();
        PCondition pconditionNode1;
        {
        PExpression pexpressionNode2;
        TGreaterThan tgreaterthanNode3;
        PExpression pexpressionNode4;
        pexpressionNode2 = (PExpression)nodeArrayList1.get(0);
        tgreaterthanNode3 = (TGreaterThan)nodeArrayList2.get(0);
        pexpressionNode4 = (PExpression)nodeArrayList3.get(0);

        pconditionNode1 = new AGreaterThanCondition(pexpressionNode2, tgreaterthanNode3, pexpressionNode4);
        }
	nodeList.add(pconditionNode1);
        return nodeList;
    }



    ArrayList new13() /* reduce AEqualCondition */
    {
        ArrayList nodeList = new ArrayList();

        ArrayList nodeArrayList3 = (ArrayList) pop();
        ArrayList nodeArrayList2 = (ArrayList) pop();
        ArrayList nodeArrayList1 = (ArrayList) pop();
        PCondition pconditionNode1;
        {
        PExpression pexpressionNode2;
        TEqual tequalNode3;
        PExpression pexpressionNode4;
        pexpressionNode2 = (PExpression)nodeArrayList1.get(0);
        tequalNode3 = (TEqual)nodeArrayList2.get(0);
        pexpressionNode4 = (PExpression)nodeArrayList3.get(0);

        pconditionNode1 = new AEqualCondition(pexpressionNode2, tequalNode3, pexpressionNode4);
        }
	nodeList.add(pconditionNode1);
        return nodeList;
    }



    ArrayList new14() /* reduce AValueExpression */
    {
        ArrayList nodeList = new ArrayList();

        ArrayList nodeArrayList1 = (ArrayList) pop();
        PExpression pexpressionNode1;
        {
        PValue pvalueNode2;
        pvalueNode2 = (PValue)nodeArrayList1.get(0);

        pexpressionNode1 = new AValueExpression(pvalueNode2);
        }
	nodeList.add(pexpressionNode1);
        return nodeList;
    }



    ArrayList new15() /* reduce APlusExpression */
    {
        ArrayList nodeList = new ArrayList();

        ArrayList nodeArrayList3 = (ArrayList) pop();
        ArrayList nodeArrayList2 = (ArrayList) pop();
        ArrayList nodeArrayList1 = (ArrayList) pop();
        PExpression pexpressionNode1;
        {
        PValue pvalueNode2;
        TPlus tplusNode3;
        PValue pvalueNode4;
        pvalueNode2 = (PValue)nodeArrayList1.get(0);
        tplusNode3 = (TPlus)nodeArrayList2.get(0);
        pvalueNode4 = (PValue)nodeArrayList3.get(0);

        pexpressionNode1 = new APlusExpression(pvalueNode2, tplusNode3, pvalueNode4);
        }
	nodeList.add(pexpressionNode1);
        return nodeList;
    }



    ArrayList new16() /* reduce AMinusExpression */
    {
        ArrayList nodeList = new ArrayList();

        ArrayList nodeArrayList3 = (ArrayList) pop();
        ArrayList nodeArrayList2 = (ArrayList) pop();
        ArrayList nodeArrayList1 = (ArrayList) pop();
        PExpression pexpressionNode1;
        {
        PValue pvalueNode2;
        TMinus tminusNode3;
        PValue pvalueNode4;
        pvalueNode2 = (PValue)nodeArrayList1.get(0);
        tminusNode3 = (TMinus)nodeArrayList2.get(0);
        pvalueNode4 = (PValue)nodeArrayList3.get(0);

        pexpressionNode1 = new AMinusExpression(pvalueNode2, tminusNode3, pvalueNode4);
        }
	nodeList.add(pexpressionNode1);
        return nodeList;
    }



    ArrayList new17() /* reduce AMultExpression */
    {
        ArrayList nodeList = new ArrayList();

        ArrayList nodeArrayList3 = (ArrayList) pop();
        ArrayList nodeArrayList2 = (ArrayList) pop();
        ArrayList nodeArrayList1 = (ArrayList) pop();
        PExpression pexpressionNode1;
        {
        PValue pvalueNode2;
        TMult tmultNode3;
        PValue pvalueNode4;
        pvalueNode2 = (PValue)nodeArrayList1.get(0);
        tmultNode3 = (TMult)nodeArrayList2.get(0);
        pvalueNode4 = (PValue)nodeArrayList3.get(0);

        pexpressionNode1 = new AMultExpression(pvalueNode2, tmultNode3, pvalueNode4);
        }
	nodeList.add(pexpressionNode1);
        return nodeList;
    }



    ArrayList new18() /* reduce ADivExpression */
    {
        ArrayList nodeList = new ArrayList();

        ArrayList nodeArrayList3 = (ArrayList) pop();
        ArrayList nodeArrayList2 = (ArrayList) pop();
        ArrayList nodeArrayList1 = (ArrayList) pop();
        PExpression pexpressionNode1;
        {
        PValue pvalueNode2;
        TDiv tdivNode3;
        PValue pvalueNode4;
        pvalueNode2 = (PValue)nodeArrayList1.get(0);
        tdivNode3 = (TDiv)nodeArrayList2.get(0);
        pvalueNode4 = (PValue)nodeArrayList3.get(0);

        pexpressionNode1 = new ADivExpression(pvalueNode2, tdivNode3, pvalueNode4);
        }
	nodeList.add(pexpressionNode1);
        return nodeList;
    }



    ArrayList new19() /* reduce AModExpression */
    {
        ArrayList nodeList = new ArrayList();

        ArrayList nodeArrayList3 = (ArrayList) pop();
        ArrayList nodeArrayList2 = (ArrayList) pop();
        ArrayList nodeArrayList1 = (ArrayList) pop();
        PExpression pexpressionNode1;
        {
        PValue pvalueNode2;
        TMod tmodNode3;
        PValue pvalueNode4;
        pvalueNode2 = (PValue)nodeArrayList1.get(0);
        tmodNode3 = (TMod)nodeArrayList2.get(0);
        pvalueNode4 = (PValue)nodeArrayList3.get(0);

        pexpressionNode1 = new AModExpression(pvalueNode2, tmodNode3, pvalueNode4);
        }
	nodeList.add(pexpressionNode1);
        return nodeList;
    }



    ArrayList new20() /* reduce AConstantValue */
    {
        ArrayList nodeList = new ArrayList();

        ArrayList nodeArrayList1 = (ArrayList) pop();
        PValue pvalueNode1;
        {
        TNumber tnumberNode2;
        tnumberNode2 = (TNumber)nodeArrayList1.get(0);

        pvalueNode1 = new AConstantValue(tnumberNode2);
        }
	nodeList.add(pvalueNode1);
        return nodeList;
    }



    ArrayList new21() /* reduce AIdentifierValue */
    {
        ArrayList nodeList = new ArrayList();

        ArrayList nodeArrayList1 = (ArrayList) pop();
        PValue pvalueNode1;
        {
        TIdentifier tidentifierNode2;
        tidentifierNode2 = (TIdentifier)nodeArrayList1.get(0);

        pvalueNode1 = new AIdentifierValue(tidentifierNode2);
        }
	nodeList.add(pvalueNode1);
        return nodeList;
    }



    ArrayList new22() /* reduce AExpressionValue */
    {
        ArrayList nodeList = new ArrayList();

        ArrayList nodeArrayList3 = (ArrayList) pop();
        ArrayList nodeArrayList2 = (ArrayList) pop();
        ArrayList nodeArrayList1 = (ArrayList) pop();
        PValue pvalueNode1;
        {
        TLPar tlparNode2;
        PExpression pexpressionNode3;
        TRPar trparNode4;
        tlparNode2 = (TLPar)nodeArrayList1.get(0);
        pexpressionNode3 = (PExpression)nodeArrayList2.get(0);
        trparNode4 = (TRPar)nodeArrayList3.get(0);

        pvalueNode1 = new AExpressionValue(tlparNode2, pexpressionNode3, trparNode4);
        }
	nodeList.add(pvalueNode1);
        return nodeList;
    }



    private static int[][][] actionTable;
/*      {
			{{-1, REDUCE, 1}, {0, SHIFT, 1}, {4, SHIFT, 2}, {7, SHIFT, 3}, {8, SHIFT, 4}, {9, SHIFT, 5}, {21, SHIFT, 6}, },
			{{-1, ERROR, 1}, {19, SHIFT, 9}, {21, SHIFT, 10}, {22, SHIFT, 11}, },
			{{-1, ERROR, 2}, {21, SHIFT, 15}, },
			{{-1, ERROR, 3}, {21, SHIFT, 16}, },
			{{-1, ERROR, 4}, {19, SHIFT, 9}, {21, SHIFT, 10}, {22, SHIFT, 11}, {23, SHIFT, 17}, },
			{{-1, ERROR, 5}, {24, SHIFT, 19}, },
			{{-1, ERROR, 6}, {10, SHIFT, 20}, },
			{{-1, ERROR, 7}, {25, ACCEPT, -1}, },
			{{-1, REDUCE, 1}, {0, SHIFT, 1}, {4, SHIFT, 2}, {7, SHIFT, 3}, {8, SHIFT, 4}, {9, SHIFT, 5}, {21, SHIFT, 6}, },
			{{-1, ERROR, 9}, {19, SHIFT, 9}, {21, SHIFT, 10}, {22, SHIFT, 11}, },
			{{-1, REDUCE, 21}, },
			{{-1, REDUCE, 20}, },
			{{-1, ERROR, 12}, {1, SHIFT, 23}, },
			{{-1, ERROR, 13}, {11, SHIFT, 24}, {12, SHIFT, 25}, {13, SHIFT, 26}, },
			{{-1, REDUCE, 14}, {14, SHIFT, 27}, {15, SHIFT, 28}, {16, SHIFT, 29}, {17, SHIFT, 30}, {18, SHIFT, 31}, },
			{{-1, ERROR, 15}, {10, SHIFT, 32}, },
			{{-1, ERROR, 16}, {24, SHIFT, 33}, },
			{{-1, ERROR, 17}, {24, SHIFT, 34}, },
			{{-1, ERROR, 18}, {24, SHIFT, 35}, },
			{{-1, REDUCE, 7}, },
			{{-1, ERROR, 20}, {19, SHIFT, 9}, {21, SHIFT, 10}, {22, SHIFT, 11}, },
			{{-1, REDUCE, 0}, },
			{{-1, ERROR, 22}, {20, SHIFT, 37}, },
			{{-1, ERROR, 23}, {24, SHIFT, 38}, },
			{{-1, ERROR, 24}, {19, SHIFT, 9}, {21, SHIFT, 10}, {22, SHIFT, 11}, },
			{{-1, ERROR, 25}, {19, SHIFT, 9}, {21, SHIFT, 10}, {22, SHIFT, 11}, },
			{{-1, ERROR, 26}, {19, SHIFT, 9}, {21, SHIFT, 10}, {22, SHIFT, 11}, },
			{{-1, ERROR, 27}, {19, SHIFT, 9}, {21, SHIFT, 10}, {22, SHIFT, 11}, },
			{{-1, ERROR, 28}, {19, SHIFT, 9}, {21, SHIFT, 10}, {22, SHIFT, 11}, },
			{{-1, ERROR, 29}, {19, SHIFT, 9}, {21, SHIFT, 10}, {22, SHIFT, 11}, },
			{{-1, ERROR, 30}, {19, SHIFT, 9}, {21, SHIFT, 10}, {22, SHIFT, 11}, },
			{{-1, ERROR, 31}, {19, SHIFT, 9}, {21, SHIFT, 10}, {22, SHIFT, 11}, },
			{{-1, ERROR, 32}, {19, SHIFT, 9}, {21, SHIFT, 10}, {22, SHIFT, 11}, },
			{{-1, REDUCE, 4}, },
			{{-1, REDUCE, 6}, },
			{{-1, REDUCE, 5}, },
			{{-1, ERROR, 36}, {24, SHIFT, 48}, },
			{{-1, REDUCE, 22}, },
			{{-1, REDUCE, 1}, {0, SHIFT, 1}, {4, SHIFT, 2}, {7, SHIFT, 3}, {8, SHIFT, 4}, {9, SHIFT, 5}, {21, SHIFT, 6}, },
			{{-1, REDUCE, 11}, },
			{{-1, REDUCE, 12}, },
			{{-1, REDUCE, 13}, },
			{{-1, REDUCE, 15}, },
			{{-1, REDUCE, 16}, },
			{{-1, REDUCE, 17}, },
			{{-1, REDUCE, 18}, },
			{{-1, REDUCE, 19}, },
			{{-1, ERROR, 47}, {5, SHIFT, 50}, },
			{{-1, REDUCE, 8}, },
			{{-1, REDUCE, 10}, {2, SHIFT, 51}, },
			{{-1, ERROR, 50}, {19, SHIFT, 9}, {21, SHIFT, 10}, {22, SHIFT, 11}, },
			{{-1, ERROR, 51}, {24, SHIFT, 54}, },
			{{-1, ERROR, 52}, {3, SHIFT, 55}, },
			{{-1, ERROR, 53}, {24, SHIFT, 56}, },
			{{-1, REDUCE, 1}, {0, SHIFT, 1}, {4, SHIFT, 2}, {7, SHIFT, 3}, {8, SHIFT, 4}, {9, SHIFT, 5}, {21, SHIFT, 6}, },
			{{-1, ERROR, 55}, {24, SHIFT, 58}, },
			{{-1, REDUCE, 1}, {0, SHIFT, 1}, {4, SHIFT, 2}, {7, SHIFT, 3}, {8, SHIFT, 4}, {9, SHIFT, 5}, {21, SHIFT, 6}, },
			{{-1, REDUCE, 9}, },
			{{-1, REDUCE, 2}, },
			{{-1, ERROR, 59}, {6, SHIFT, 60}, },
			{{-1, ERROR, 60}, {24, SHIFT, 61}, },
			{{-1, REDUCE, 3}, },
        };*/
    private static int[][][] gotoTable;
/*      {
			{{-1, 7}, {8, 21}, {38, 49}, {54, 57}, {56, 59}, },
			{{-1, 8}, },
			{{-1, 52}, },
			{{-1, 12}, },
			{{-1, 13}, {4, 18}, {9, 22}, {20, 36}, {24, 39}, {25, 40}, {26, 41}, {32, 47}, {50, 53}, },
			{{-1, 14}, {27, 42}, {28, 43}, {29, 44}, {30, 45}, {31, 46}, },
        };*/
    private static String[] errorMessages;
/*      {
			"expecting: 'IF', 'FOR', 'READ', 'PRINT', 'PRINTLN', identifier, EOF",
			"expecting: '(', identifier, number",
			"expecting: identifier",
			"expecting: '(', identifier, number, string",
			"expecting: new line",
			"expecting: ':='",
			"expecting: EOF",
			"expecting: 'IF', 'ELSE', 'ENDIF', 'FOR', 'NEXT', 'READ', 'PRINT', 'PRINTLN', identifier, EOF",
			"expecting: 'THEN', 'TO', '<', '>', '=', '+', '-', '*', '/', '%', ')', new line",
			"expecting: 'THEN'",
			"expecting: '<', '>', '='",
			"expecting: 'ELSE', 'ENDIF', 'NEXT', EOF",
			"expecting: ')'",
			"expecting: 'IF', 'ELSE', 'ENDIF', 'FOR', 'READ', 'PRINT', 'PRINTLN', identifier",
			"expecting: 'THEN', 'TO', '<', '>', '=', ')', new line",
			"expecting: 'TO'",
			"expecting: 'ELSE', 'ENDIF'",
			"expecting: 'ENDIF'",
			"expecting: 'IF', 'ENDIF', 'FOR', 'READ', 'PRINT', 'PRINTLN', identifier",
			"expecting: 'IF', 'FOR', 'NEXT', 'READ', 'PRINT', 'PRINTLN', identifier",
			"expecting: 'NEXT'",
        };*/
    private static int[] errors;
/*      {
			0, 1, 2, 2, 3, 4, 5, 6, 7, 1, 8, 8, 9, 10, 8, 5, 4, 4, 4, 7, 1, 11, 12, 4, 1, 1, 1, 1, 1, 1, 1, 1, 1, 7, 7, 7, 4, 8, 13, 9, 9, 9, 14, 14, 14, 14, 14, 15, 7, 16, 1, 4, 17, 4, 18, 4, 19, 17, 7, 20, 4, 7, 
        };*/

    static 
    {
        try
        {
            DataInputStream s = new DataInputStream(
                new BufferedInputStream(
                Parser.class.getResourceAsStream("parser.dat")));

            // read actionTable
            int length = s.readInt();
            actionTable = new int[length][][];
            for(int i = 0; i < actionTable.length; i++)
            {
                length = s.readInt();
                actionTable[i] = new int[length][3];
                for(int j = 0; j < actionTable[i].length; j++)
                {
                for(int k = 0; k < 3; k++)
                {
                    actionTable[i][j][k] = s.readInt();
                }
                }
            }

            // read gotoTable
            length = s.readInt();
            gotoTable = new int[length][][];
            for(int i = 0; i < gotoTable.length; i++)
            {
                length = s.readInt();
                gotoTable[i] = new int[length][2];
                for(int j = 0; j < gotoTable[i].length; j++)
                {
                for(int k = 0; k < 2; k++)
                {
                    gotoTable[i][j][k] = s.readInt();
                }
                }
            }

            // read errorMessages
            length = s.readInt();
            errorMessages = new String[length];
            for(int i = 0; i < errorMessages.length; i++)
            {
                length = s.readInt();
                StringBuffer buffer = new StringBuffer();

                for(int j = 0; j < length; j++)
                {
                buffer.append(s.readChar());
                }
                errorMessages[i] = buffer.toString();
            }

            // read errors
            length = s.readInt();
            errors = new int[length];
            for(int i = 0; i < errors.length; i++)
            {
                errors[i] = s.readInt();
            }

            s.close();
        }
        catch(Exception e)
        {
            throw new RuntimeException("The file \"parser.dat\" is either missing or corrupted.");
        }
    }
}
